#include <bits/stdc++.h>
using namespace std;


const long long MAXN = 2e5 + 10;
vector <tuple <long long, long long, long long>> edges[MAXN];
long long n, m;

long long t[MAXN];

long long dijkstra(long long max_p) {
    fill(t, t + MAXN, LLONG_MAX);
    priority_queue <pair <long long, long long>, vector <pair <long long, long long>>, greater <pair <long long, long long>>> pq;
    pq.push({0, 1});

    while (pq.size()) {
        auto [tt, u] = pq.top();
        pq.pop();

        if (t[u] <= tt) continue;
        t[u] = tt;

        for (auto [ttt, p, v] : edges[u]) {
            if (p <= max_p) pq.push({tt + ttt, v});
        }
    }

    return t[n];
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long max_p = 0;
    cin >> n >> m;

    for (long long i = 1; i <= m; i++) {
        long long u, v, p, t;
        cin >> u >> v >> p >> t;

        max_p = max(max_p, p);

        edges[u].push_back({t, p, v});
        edges[v].push_back({t, p, u});
    }

    long long l = 1, r = max_p;
    pair <long long, long long> ans;

    while (l <= r) {
        long long m = (l + r) / 2;

        long long val = dijkstra(m);

        if (val != LLONG_MAX) {
            ans = {m, val};
            r = m - 1;
        } else l = m + 1;
    }

    cout << ans.first << ' ' << ans.second << endl;
    return 0;

}
