#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>
using namespace std;
const long long MAXN=2*1e5+10;
const long long INF=1e18;
vector<pair<long long,long long>> gp[MAXN];
vector<pair<long long,long long>> gw[MAXN];
vector<bool> visp(MAXN,0);
vector<bool> visw(MAXN,0);
vector<long long> distp(MAXN,INF);
vector<long long> distw(MAXN,INF);
long long n,m;
void dijkstrap(long long s){
    priority_queue<pair<long long,long long>,vector<pair<long long,long long>>, greater<pair<long long,long long>>> pq;
    pq.push({0,s});
    while(!pq.empty()){
        auto [x,d]=pq.top();
        pq.pop();
        if(visp[d]){
            continue;
        }
        visp[d]=1;
        distp[d]=x;
        for(long long i=0;i<gp[d].size();i++){
            if(visp[gp[d][i].first]){
                continue;
            }
            if(distp[gp[d][i].first]>max(x,gp[d][i].second)){
                pq.push({max(x,gp[d][i].second),gp[d][i].first});
                distp[gp[d][i].first]=max(x,gp[d][i].second);
            }
        }
    }
}
void dijkstraw(long long s){
    priority_queue<pair<long long,long long>,vector<pair<long long,long long>>, greater<pair<long long,long long>>> pq;
    pq.push({0,s});
    while(!pq.empty()){
        auto [x,d]=pq.top();
        pq.pop();
        if(visw[d]){
            continue;
        }
        visw[d]=1;
        distw[d]=x;
        for(long long i=0;i<gw[d].size();i++){
            if(visw[gw[d][i].first]){
                continue;
            }
            if(gp[d][i].second>distp[n]){
                continue;
            }
            if(distw[gw[d][i].first]>x+gw[d][i].second){
                pq.push({x+gw[d][i].second,gw[d][i].first});
                distw[gw[d][i].first]=x+gw[d][i].second;
            }
        }
    }
}
int main(){
    cin>>n>>m;
    for(long long i=1;i<=m;i++){
        long long u,v,p,w;
        cin>>u>>v>>p>>w;
        gp[u].push_back({v,p});
        gp[v].push_back({u,p});
        gw[u].push_back({v,w});
        gw[v].push_back({u,w});
    }
    dijkstrap(1);
    dijkstraw(1);
    cout<<distp[n]<<" "<<distw[n]<<endl;
    return 0;
}
