#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <climits>
#include <queue>
#include <cassert>
#define endl '\n'
using namespace std;
long long dP[800005];
long long dW[800005];
int n,m;
struct edge
{
    int ver;
    long long distP, distW;
    edge(int v, long long d1, long long d2)
    {
        ver = v, distP = d1, distW = d2;
    }
    ~edge() {}
    const bool operator<(edge a) const
    {
        if(distP != a.distP)
        {
            return distP > a.distP;
        }
        return distW > a.distW;
    }
};
vector<edge> g[800005];
void dijkstra()
{
    priority_queue<edge> q;
    q.push({1, 0, 0});
    while(!q.empty())
    {
        edge c = q.top();
        q.pop();
        for(edge x : g[c.ver])
        {
            if(dP[x.ver] > max(dP[c.ver],x.distP) || (dP[x.ver] == max(dP[c.ver],x.distP) && dW[x.ver]>=dW[c.ver]+x.distW))   // ?
            {
                dP[x.ver] = max(dP[c.ver],x.distP);
                dW[x.ver] = dW[c.ver]+x.distW;
                x.distP = dP[x.ver];
                x.distW = dW[x.ver];
                q.push(x);
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        long long w,p;
        int u,v;
        cin >> u >> v >> p >> w;
        g[u].push_back({v, p, w});
        g[v].push_back({u, p, w});
    }
    dP[1]=0, dW[1]=0;
    for(int i = 2; i <= n; i++)
    {
        dP[i]=6e18, dW[i]=6e18;
    }
    dijkstra();
    assert(dW[n]>=2e18);
    cout << dP[n] << " " << dW[n];
}
