#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <queue>
#define endl '\n'
using namespace std;
long long dP[300005];
long long dW[300005];
long long par[300005];
long long n,m;
struct edge {
    long long ver, distP, distW;
    edge(long long v, long long d1, long long d2) {ver = v, distP = d1, distW = d2;}
    ~edge(){}
    const bool operator<(edge a) const {
        if(distP != a.distP) {
            return distP < a.distP;
        }
        else return distW < a.distW;
    }
};
vector<edge> g[300005];
void dijkstra() {
    priority_queue<edge> q;
    q.push({1, 0, 0});
    while(!q.empty()) {
        edge c = q.top(); q.pop();
        for(edge x : g[c.ver]) {
            if(dP[x.ver] > max(dP[c.ver],x.distP) ||
               (dP[x.ver] == max(dP[c.ver],x.distP) && dW[x.ver]>dW[c.ver]+x.distW)) {
                dP[x.ver] = max(dP[c.ver],x.distP);
                dW[x.ver] = dW[c.ver]+x.distW;
                //par[x.ver]=c.ver;
                q.push(x);
            }
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    cin >> n >> m;
    for(long long i = 0; i < m; i++) {
        long long u,v,w,p; cin >> u >> v >> p >> w;
        g[u].push_back({v, p, w});
        g[v].push_back({u, p, w});
    }
    dP[1]=0, dW[1]=0;
    for(long long i = 2; i <= n; i++) {
        dP[i]=2e9, dW[i]=2e9;
    }
    dijkstra();
    cout << dP[n] << " " << dW[n] << endl;
}
