#include <iostream>
#include <vector>
#include <queue>
using namespace std;
int n, m;
struct edge
{
    long long ver, dist, cost;
    bool operator < (const edge &e)const
    {
        if(dist < e.dist)return 1;
        if(dist > e.dist)return 0;
        return cost < e.cost;
    }
};
vector <edge> v[200005];
long long d[200005], s[200005];
void read()
{
    cin >> n >> m;
    int u, v1, p, w;
    for(int i = 1; i <= m; i++)
    {
        cin >> u >> v1>> p >> w;
        v[u].push_back({v1, p, w});
        v[v1].push_back({u, p, w});
        if(u== 1)d[v1] = p;
    }
}

void init()
{
    for(int i = 2; i <= n; i++)
        d[i] = 1e9;
    d[1] =1;
}
void dijkstra(int beg)
{
    queue <edge> pq;
    pq.push({beg, 1, 1});
    while(!pq.empty())
    {
        int ver = pq.front().ver;
        long long dist = pq.front().dist;
        long long cost = pq.front().cost;
        pq.pop();
        for(int i = 0; i < v[ver].size(); i++)
        {
            if(d[v[ver][i].ver] > max(dist, v[ver][i].dist))
            {
                d[v[ver][i].ver] = max(dist, v[ver][i].dist);
                pq.push({v[ver][i].ver, d[v[ver][i].ver], 0});
            }
            else if(d[v[ver][i].ver] == max(d[ver], v[ver][i].dist))
            {
                if(s[v[ver][i].ver] > cost + v[ver][i].cost)
                {
                    s[v[ver][i].ver] = cost + v[ver][i].cost;
                    pq.push({v[ver][i].ver, d[v[ver][i].ver], s[v[ver][i].ver]});
                }
            }
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    init();
    dijkstra(1);
    if(d[n] == 1e9)d[n] = 1;
    cout << d[n] << " " << 1 << endl;
    return 0;
}
